require 'socket'

module AvocadoFormatter
  class Cucumber

    def label(feature)
      feature.short_name
    end

    def initialize(runtime, path_or_io, options)
        @runtime, @io, @options = runtime, ensure_io(path_or_io), options
        @hostname = 'localhost'
        @port = '1336'
        @socket = TCPSocket.open(@hostname, @port)
        @socket.puts(@runtime.scenarios.length);
        @socket.puts(@runtime.steps.length);
      end

    def before_feature(feature)
      # @io.print "#{label(feature)} "
      # @io.flush
      # @exceptions = []
      # @start_time = Time.now
      @socket.puts(label(feature));
    end

    def after_feature(feature)
      # print_elapsed_time @io, @start_time
      # @io.puts
      #
      # @exceptions.each do |(exception, status)|
      #   print_exception(exception, status, 2)
      # end
    end

    def exception(exception, status)
      @exceptions << [exception, status]
      super if defined?(super)
    end

    def after_features(features)
      # @io.puts
      # print_stats(features, @options)
      # print_snippets(@options)
      # print_passing_wip(@options)
    end

    CHARS = {
        :passed    => '.',
        :failed    => 'F',
        :undefined => 'U',
        :pending   => 'P',
        :skipped   => '-'
      }

      def progress(status)
        char = CHARS[status]
        @socket.puts(char);
        # @io.print(format_string(char, status))
        # @io.flush
      end

    def done
    end
  end
end
